import numpy, cv2

cap = cv2.VideoCapture(1)
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_WIDTH, 640)
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT, 480)
#cv2.ocl.setUseOpenCL(False)
max_pts = 300
# SURF with the Hessian parameter
#sift = cv2.SURF(2000)
sift = cv2.ORB_create(max_pts)

bf = cv2.BFMatcher(crossCheck=False) # Bruteforce matcher
desc0 = None # To store descriptors
color = numpy.random.randint(0,255,(max_pts,3)) # Random color for kp

while 1:
    stat, image = cap.read(0)
    image = cv2.resize(image, (image.shape[1]/2, image.shape[0]/2))

    # Find keypoints and their descriptors
    #kp, desc = sift.detectAndCompute(image, None)
    kp = sift.detect(image)
    kp, desc = sift.compute(image, kp)
    cv2.drawKeypoints(image, kp, image, color=(0,255,0))

    if desc0 != None:
        # Match the saved and the latest kp's
        matches = bf.knnMatch(desc0, desc, 2)

        for i in range(min(max_pts,len(matches))):
            # Matched pair: kp0[m.queryIdx] <--> kp[m.trainIdx]
            m = matches[i]
            if m[0].distance > m[1].distance*0.7:
                continue
            (a, b) = kp[m[0].trainIdx].pt
            (c, d) = kp0[m[0].queryIdx].pt
            cv2.circle(image, (int(a), int(b)), 5,\
                       color[m[0].queryIdx%max_pts].tolist(), -1)
            cv2.line(image, (int(a), int(b)), (int(c), int(d)),\
                     color[m[0].queryIdx%max_pts].tolist(), 2)

    cv2.imshow('Camera', image)
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        break
    elif key == 0x20:
        desc0 = desc.copy()
        kp0 = kp[:]
        print 'Target updated!'
